// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_general_purpose_radar_msgs:msg/TargetA.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_GENERAL_PURPOSE_RADAR_MSGS__MSG__DETAIL__TARGET_A__STRUCT_HPP_
#define OFF_HIGHWAY_GENERAL_PURPOSE_RADAR_MSGS__MSG__DETAIL__TARGET_A__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_general_purpose_radar_msgs__msg__TargetA __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_general_purpose_radar_msgs__msg__TargetA __declspec(deprecated)
#endif

namespace off_highway_general_purpose_radar_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TargetA_
{
  using Type = TargetA_<ContainerAllocator>;

  explicit TargetA_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_id = 0ul;
      this->id = 0;
      this->radial_distance = 0.0;
      this->radial_velocity = 0.0;
      this->reflected_power = 0.0;
      this->azimuth_angle = 0.0;
      this->measured = false;
    }
  }

  explicit TargetA_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_id = 0ul;
      this->id = 0;
      this->radial_distance = 0.0;
      this->radial_velocity = 0.0;
      this->reflected_power = 0.0;
      this->azimuth_angle = 0.0;
      this->measured = false;
    }
  }

  // field types and members
  using _can_id_type =
    uint32_t;
  _can_id_type can_id;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;
  using _id_type =
    uint8_t;
  _id_type id;
  using _radial_distance_type =
    double;
  _radial_distance_type radial_distance;
  using _radial_velocity_type =
    double;
  _radial_velocity_type radial_velocity;
  using _reflected_power_type =
    double;
  _reflected_power_type reflected_power;
  using _azimuth_angle_type =
    double;
  _azimuth_angle_type azimuth_angle;
  using _measured_type =
    bool;
  _measured_type measured;

  // setters for named parameter idiom
  Type & set__can_id(
    const uint32_t & _arg)
  {
    this->can_id = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }
  Type & set__id(
    const uint8_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__radial_distance(
    const double & _arg)
  {
    this->radial_distance = _arg;
    return *this;
  }
  Type & set__radial_velocity(
    const double & _arg)
  {
    this->radial_velocity = _arg;
    return *this;
  }
  Type & set__reflected_power(
    const double & _arg)
  {
    this->reflected_power = _arg;
    return *this;
  }
  Type & set__azimuth_angle(
    const double & _arg)
  {
    this->azimuth_angle = _arg;
    return *this;
  }
  Type & set__measured(
    const bool & _arg)
  {
    this->measured = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_general_purpose_radar_msgs__msg__TargetA
    std::shared_ptr<off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_general_purpose_radar_msgs__msg__TargetA
    std::shared_ptr<off_highway_general_purpose_radar_msgs::msg::TargetA_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TargetA_ & other) const
  {
    if (this->can_id != other.can_id) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->radial_distance != other.radial_distance) {
      return false;
    }
    if (this->radial_velocity != other.radial_velocity) {
      return false;
    }
    if (this->reflected_power != other.reflected_power) {
      return false;
    }
    if (this->azimuth_angle != other.azimuth_angle) {
      return false;
    }
    if (this->measured != other.measured) {
      return false;
    }
    return true;
  }
  bool operator!=(const TargetA_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TargetA_

// alias to use template instance with default allocator
using TargetA =
  off_highway_general_purpose_radar_msgs::msg::TargetA_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_general_purpose_radar_msgs

#endif  // OFF_HIGHWAY_GENERAL_PURPOSE_RADAR_MSGS__MSG__DETAIL__TARGET_A__STRUCT_HPP_
